(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('underscore'), require('@angular/common')) :
	typeof define === 'function' && define.amd ? define('iwe7-underscore', ['exports', '@angular/core', 'underscore', '@angular/common'], factory) :
	(factory((global['iwe7-underscore'] = {}),global.ng.core,global.underscore,global.ng.common));
}(this, (function (exports,core,underscore,common) { 'use strict';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0
THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.
See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */










function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}
function __spread() {
    for (var ar = [], i = 0; i < arguments.length; i++)
        ar = ar.concat(__read(arguments[i]));
    return ar;
}

var MapPipe = /** @class */ (function () {
    function MapPipe() {
    }
    MapPipe.prototype.transform = function (value, args) {
        var re = underscore.map(value, function (item, key) {
            return { item: item, key: key };
        });
        return re;
    };
    return MapPipe;
}());
MapPipe.decorators = [
    { type: core.Pipe, args: [{
                name: "map"
            },] },
];
MapPipe.ctorParameters = function () { return []; };
var ShufflePipe = /** @class */ (function () {
    function ShufflePipe() {
    }
    ShufflePipe.prototype.transform = function (value, args) {
        return underscore.shuffle(value);
    };
    return ShufflePipe;
}());
ShufflePipe.decorators = [
    { type: core.Pipe, args: [{
                name: 'shuffle'
            },] },
];
ShufflePipe.ctorParameters = function () { return []; };
var SamplePipe = /** @class */ (function () {
    function SamplePipe() {
    }
    SamplePipe.prototype.transform = function (value, args) {
        var item = underscore.sample(value, args);
        return item;
    };
    return SamplePipe;
}());
SamplePipe.decorators = [
    { type: core.Pipe, args: [{
                name: "sample"
            },] },
];
SamplePipe.ctorParameters = function () { return []; };
var RangePipe = /** @class */ (function () {
    function RangePipe() {
    }
    RangePipe.prototype.transform = function (value, args) {
        return underscore.range(value, args);
    };
    return RangePipe;
}());
RangePipe.decorators = [
    { type: core.Pipe, args: [{
                name: "range"
            },] },
];
RangePipe.ctorParameters = function () { return []; };
var FlattenPipe = /** @class */ (function () {
    function FlattenPipe() {
    }
    FlattenPipe.prototype.transform = function (value, args) {
        return underscore.flatten(value);
    };
    return FlattenPipe;
}());
FlattenPipe.decorators = [
    { type: core.Pipe, args: [{
                name: "flatten"
            },] },
];
FlattenPipe.ctorParameters = function () { return []; };
var ValuesPipe = /** @class */ (function () {
    function ValuesPipe() {
    }
    ValuesPipe.prototype.transform = function (value, args) {
        return underscore.values(value);
    };
    return ValuesPipe;
}());
ValuesPipe.decorators = [
    { type: core.Pipe, args: [{
                name: 'values'
            },] },
];
ValuesPipe.ctorParameters = function () { return []; };
var InvertPipe = /** @class */ (function () {
    function InvertPipe() {
    }
    InvertPipe.prototype.transform = function (value, args) {
        return underscore.invert(value);
    };
    return InvertPipe;
}());
InvertPipe.decorators = [
    { type: core.Pipe, args: [{
                name: 'invert'
            },] },
];
InvertPipe.ctorParameters = function () { return []; };
var PIPES = [
    MapPipe,
    ShufflePipe,
    SamplePipe,
    RangePipe,
    FlattenPipe,
    ValuesPipe,
    InvertPipe
];
var UnderscoreModule = /** @class */ (function () {
    function UnderscoreModule() {
    }
    return UnderscoreModule;
}());
UnderscoreModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [common.CommonModule],
                declarations: __spread(PIPES),
                exports: __spread(PIPES)
            },] },
];
UnderscoreModule.ctorParameters = function () { return []; };

exports.UnderscoreModule = UnderscoreModule;
exports.ɵf = FlattenPipe;
exports.ɵh = InvertPipe;
exports.ɵb = MapPipe;
exports.ɵe = RangePipe;
exports.ɵd = SamplePipe;
exports.ɵc = ShufflePipe;
exports.ɵa = PIPES;
exports.ɵg = ValuesPipe;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=iwe7-underscore.umd.js.map
