import { Pipe, NgModule } from '@angular/core';
import { map, shuffle, sample, range, flatten, values, invert } from 'underscore';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class MapPipe {
    /**
     * @param {?} value
     * @param {?=} args
     * @return {?}
     */
    transform(value, args) {
        let /** @type {?} */ re = map(value, (item, key) => {
            return { item: item, key: key };
        });
        return re;
    }
}
MapPipe.decorators = [
    { type: Pipe, args: [{
                name: "map"
            },] },
];
/** @nocollapse */
MapPipe.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class ShufflePipe {
    /**
     * @param {?} value
     * @param {?=} args
     * @return {?}
     */
    transform(value, args) {
        return shuffle(value);
    }
}
ShufflePipe.decorators = [
    { type: Pipe, args: [{
                name: 'shuffle'
            },] },
];
/** @nocollapse */
ShufflePipe.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class SamplePipe {
    /**
     * @param {?} value
     * @param {?=} args
     * @return {?}
     */
    transform(value, args) {
        let /** @type {?} */ item = sample(value, args);
        return item;
    }
}
SamplePipe.decorators = [
    { type: Pipe, args: [{
                name: "sample"
            },] },
];
/** @nocollapse */
SamplePipe.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class RangePipe {
    /**
     * @param {?} value
     * @param {?=} args
     * @return {?}
     */
    transform(value, args) {
        return range(value, args);
    }
}
RangePipe.decorators = [
    { type: Pipe, args: [{
                name: "range"
            },] },
];
/** @nocollapse */
RangePipe.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class FlattenPipe {
    /**
     * @param {?} value
     * @param {?=} args
     * @return {?}
     */
    transform(value, args) {
        return flatten(value);
    }
}
FlattenPipe.decorators = [
    { type: Pipe, args: [{
                name: "flatten"
            },] },
];
/** @nocollapse */
FlattenPipe.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class ValuesPipe {
    /**
     * @param {?} value
     * @param {?=} args
     * @return {?}
     */
    transform(value, args) {
        return values(value);
    }
}
ValuesPipe.decorators = [
    { type: Pipe, args: [{
                name: 'values'
            },] },
];
/** @nocollapse */
ValuesPipe.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class InvertPipe {
    /**
     * @param {?} value
     * @param {?=} args
     * @return {?}
     */
    transform(value, args) {
        return invert(value);
    }
}
InvertPipe.decorators = [
    { type: Pipe, args: [{
                name: 'invert'
            },] },
];
/** @nocollapse */
InvertPipe.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
const PIPES = [
    MapPipe,
    ShufflePipe,
    SamplePipe,
    RangePipe,
    FlattenPipe,
    ValuesPipe,
    InvertPipe
];
class UnderscoreModule {
}
UnderscoreModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                declarations: [...PIPES],
                exports: [...PIPES]
            },] },
];
/** @nocollapse */
UnderscoreModule.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * Generated bundle index. Do not edit.
 */

export { UnderscoreModule, FlattenPipe as ɵf, InvertPipe as ɵh, MapPipe as ɵb, RangePipe as ɵe, SamplePipe as ɵd, ShufflePipe as ɵc, PIPES as ɵa, ValuesPipe as ɵg };
//# sourceMappingURL=iwe7-underscore.js.map
