import { __spread } from 'tslib';
import { Pipe, NgModule } from '@angular/core';
import { map, shuffle, sample, range, flatten, values, invert } from 'underscore';
import { CommonModule } from '@angular/common';

var MapPipe = /** @class */ (function () {
    function MapPipe() {
    }
    MapPipe.prototype.transform = function (value, args) {
        var re = map(value, function (item, key) {
            return { item: item, key: key };
        });
        return re;
    };
    return MapPipe;
}());
MapPipe.decorators = [
    { type: Pipe, args: [{
                name: "map"
            },] },
];
MapPipe.ctorParameters = function () { return []; };
var ShufflePipe = /** @class */ (function () {
    function ShufflePipe() {
    }
    ShufflePipe.prototype.transform = function (value, args) {
        return shuffle(value);
    };
    return ShufflePipe;
}());
ShufflePipe.decorators = [
    { type: Pipe, args: [{
                name: 'shuffle'
            },] },
];
ShufflePipe.ctorParameters = function () { return []; };
var SamplePipe = /** @class */ (function () {
    function SamplePipe() {
    }
    SamplePipe.prototype.transform = function (value, args) {
        var item = sample(value, args);
        return item;
    };
    return SamplePipe;
}());
SamplePipe.decorators = [
    { type: Pipe, args: [{
                name: "sample"
            },] },
];
SamplePipe.ctorParameters = function () { return []; };
var RangePipe = /** @class */ (function () {
    function RangePipe() {
    }
    RangePipe.prototype.transform = function (value, args) {
        return range(value, args);
    };
    return RangePipe;
}());
RangePipe.decorators = [
    { type: Pipe, args: [{
                name: "range"
            },] },
];
RangePipe.ctorParameters = function () { return []; };
var FlattenPipe = /** @class */ (function () {
    function FlattenPipe() {
    }
    FlattenPipe.prototype.transform = function (value, args) {
        return flatten(value);
    };
    return FlattenPipe;
}());
FlattenPipe.decorators = [
    { type: Pipe, args: [{
                name: "flatten"
            },] },
];
FlattenPipe.ctorParameters = function () { return []; };
var ValuesPipe = /** @class */ (function () {
    function ValuesPipe() {
    }
    ValuesPipe.prototype.transform = function (value, args) {
        return values(value);
    };
    return ValuesPipe;
}());
ValuesPipe.decorators = [
    { type: Pipe, args: [{
                name: 'values'
            },] },
];
ValuesPipe.ctorParameters = function () { return []; };
var InvertPipe = /** @class */ (function () {
    function InvertPipe() {
    }
    InvertPipe.prototype.transform = function (value, args) {
        return invert(value);
    };
    return InvertPipe;
}());
InvertPipe.decorators = [
    { type: Pipe, args: [{
                name: 'invert'
            },] },
];
InvertPipe.ctorParameters = function () { return []; };
var PIPES = [
    MapPipe,
    ShufflePipe,
    SamplePipe,
    RangePipe,
    FlattenPipe,
    ValuesPipe,
    InvertPipe
];
var UnderscoreModule = /** @class */ (function () {
    function UnderscoreModule() {
    }
    return UnderscoreModule;
}());
UnderscoreModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                declarations: __spread(PIPES),
                exports: __spread(PIPES)
            },] },
];
UnderscoreModule.ctorParameters = function () { return []; };

export { UnderscoreModule, FlattenPipe as ɵf, InvertPipe as ɵh, MapPipe as ɵb, RangePipe as ɵe, SamplePipe as ɵd, ShufflePipe as ɵc, PIPES as ɵa, ValuesPipe as ɵg };
//# sourceMappingURL=iwe7-underscore.js.map
